package felix.main;

import java.sql.ResultSet;
import java.sql.SQLWarning;
import java.sql.Statement;
import java.util.HashMap;

import tuffy.db.RDB;
import tuffy.util.Config;
import tuffy.util.UIMan;
import felix.dstruct.FelixPredicate;
import felix.parser.FelixCommandOptions;
//import felix.util.ActiveLearner;
//import felix.util.CostCalculator;
import felix.util.ActiveLearner;
import felix.util.CostCalculator;
import felix.util.FelixConfig;
import felix.util.FelixUIMan;
import felix.util.TimeOut;

/**
 * Main class of Felix.
 * @author Ce Zhang
 *
 */
public class Main {

	public static void main(String[] args) throws Exception {
		
		
		FelixConfig.overrideID();
		FelixCommandOptions options = FelixUIMan.parseCommand(args);
		FelixConfig.evidDBSchema = options.evidDBSchema;
		FelixConfig.gp = options.isGreenPlum;
		
		
		
		FelixUIMan.println("*** Welcome to " + FelixConfig.product_name + "");
		if(options == null){
			return;
		}
		
		TimeOut to = null;
		if(options.timeout < Integer.MAX_VALUE){
			to = new TimeOut(options.timeout);
			to.start();
		}


		if(options.utilModel != null){

			
			if(options.utilModel.equals("incremental")){

				ActiveLearner al = new ActiveLearner(options);

				al.DjangoSetup();

			}
			
			if(options.utilModel.equals("cost")){
				CostCalculator cc = new CostCalculator(options);
				cc.calc();
			}
			
		}else{
			if(!options.isDLearningMode){
				
				new Felix().run(options);

				
			}else{
				UIMan.println("Please use Tuffy for MLN learning.");
			}
		}
		
		if(options.timeout < Integer.MAX_VALUE){
			to.stop();
		}
		
	}
	
}




