package felix.parser;

import org.kohsuke.args4j.Option;

/**
 * Class that contains Felix-specific command line options.
 * @author Ce Zhang
 *
 */
public class FelixCommandOptions extends tuffy.parse.CommandOptions{
	
    @Option(name="-useEvid", usage="Load evidence file before parsing operators.")
    public boolean useEvid = false;
	
    //@Option(name="-dParts", usage="Number of data partitions.")
    //public int degreeOfPartition = 1;
    
    //@Option(name="-nCores", usage="Number of CPU cores.")
    //public int nCores = 1;
    
    @Option(name="-spTuffy", usage="Statistically decompose Tuffy Operator.")
    public boolean decomposeTuffy = false;
    
    /////////////////////////////////
    @Option(name="-explain", usage="Explain mode of Felix.")
    public boolean explainMode = false;
	
    @Option(name="-allRuleAsMLN", usage="Close the Felix compilier.")
    public boolean allRuleAsMLN = false;
        
    /////////////////////////////////
    @Option(name="-dd", usage="Decompose the rules aggressively in the sense that each predicate can have an LR component.")
    public boolean useDualDecomposition = false;
    
    
    @Option(name="-noCRF", usage="Do not use CRF operator.")
    public boolean noCRF = false;
    
    @Option(name="-noCOREF", usage="Do not use COREF operator.")
    public boolean noCOREF = false;
    
    @Option(name="-noLR", usage="Do not use LR operator.")
    public boolean noLR = false;
    
    @Option(name="-allView", usage="Do not use LR operator.")
    public boolean allView = false;
    
    @Option(name="-allMat", usage="Do not use LR operator.")
    public boolean allMat = false;
    
    
    

    /////////////////////////////////
    @Option(name="-local", usage="Connect to local hadoop.")
    public boolean local = false;
    
    /////////////////////////////////
    @Option(name="-auxSchema", usage="Schema used for saving hadoop views.")
    public String auxSchema = null;
    
    @Option(name="-forceExt", usage="Force to run the feature extraction phase!")
    public boolean forceExt = false;
    

    
    /////////////////////////////////
    @Option(name="-gp", usage="")
    public boolean isGreenPlum = false;

    

    
    
    
    @Option(name="-util", usage="Fire certain util model of Felix. {\"dump\" = translate a general database to the format that Felix can read. }")
    public String utilModel = null;
    
    @Option(name="-incRule", usage="Incremental update rule file.")
    public String incRule = null;
    
    @Option(name="-incEvid", usage="Incremental update evidence file.")
    public String incEvid = null;
    
    @Option(name="-gt", usage="Ground truth file.")
    public String gt = null;
    
    
    
    ///////////////////////////////////////
    @Option(name="-nReduce", usage="Number of REDUCER.")
    public int nReduce = 30;
    
    ///////////////////////////////////////
    @Option(name="-nDD", usage="Number of Dual Decomposition Iteration.")
    public int nDD = 1;
    
    /////////////////////////////////////////
    @Option(name="-hdfs", usage="Address of HDFS.")
    public String hdfs = "hdfs://d-02.cs.wisc.edu:9000/";
        
    ////////////////////////////////////////
    @Option(name="-mapreduce", usage="Address of MAPREDUCE.")
    public String mapreduce = "hdfs://d-02.cs.wisc.edu:9001/";
    
}









