package felix.society;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Future;

import felix.society.Task.TaskType;
import felix.society.TaskList.TaskListExecutionWorker;

/**
 * TaskSet -- Subtasks in it can be executed in parallel
 * (and then joined).
 * 
 * 
 * @author czhang
 *
 */
public class TaskSet extends Task{

	public TaskSet(){
		super(TaskType.TASKSET);
	}
	
	public TaskSet(Integer _nRuns){
		super(TaskType.TASKSET, _nRuns);
	}
	
	@Override
	public Worker generateWorker() {
		return null;
	}
	
	public Worker generateWorker(ExecutorService pool) {
		return new TaskSetExecutionWorker(this.subTasks, pool);
	}

	/**
	 * Worker for running this TaskSet.
	 * @author czhang
	 *
	 */
	public class TaskSetExecutionWorker extends Worker{
		
		ArrayList<Task> subtasks;
		ExecutorService pool;
		
		public TaskSetExecutionWorker(ArrayList<Task> _subtasks,
				ExecutorService _pool){
			subtasks = _subtasks;
			pool = _pool;
		}

		@Override
		public void run() {
			
			try{
				
				ArrayList<Future> futures = new ArrayList<Future>();
				
				for(Task t : subTasks){
					if(t.getType() == TaskType.TASK){
						currentWorker = t.generateWorker();
						currentFuture = pool.submit(currentWorker);
						futures.add(currentFuture);
					}else{
						currentWorker = t.generateWorker(pool);
						currentFuture = softpool.submit(currentWorker);
						futures.add(currentFuture);
					}
				}
				
				for(Future f : futures){
					f.get();
				}
				
			}catch(Exception e){
				submitException(e);
			}
		}
		
	}

}










