package felix.society;

import tuffy.util.Config;


/**
 * A worker is a Runnable object generated by Task/TaskList/TaskWorker.
 * @author czhang
 *
 */
public abstract class Worker implements Runnable{

	/**
	 * Exception collected
	 */
	private Exception e = null;
	
	/**
	 * ID
	 */
	protected int id = -1;
	
	/**
	 * Constructor -- the ID is assigned here.
	 */
	public Worker(){
		this.id = Config.getNextGlobalCounter();
	}
	
	/**
	 * If there are exceptions collected while running
	 * this Worker, return it.
	 * @return
	 */
	public Exception getException(){
		return e;
	}
	
	/**
	 * Collect exceptions while running (we cannot
	 * throw exceptions in run())
	 * @param _e
	 */
	public void submitException(Exception _e){
		this.e = _e;
	}
	
	/**
	 * Run!!!!
	 */
	public abstract void run();
	
}
