package felix.test;

import static org.junit.Assert.*;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.junit.Test;

import tuffy.util.UIMan;
import felix.main.Felix;
import felix.parser.FelixCommandOptions;
import felix.util.FelixConfig;
import felix.util.FelixUIMan;

/**
 * Test Coref operator's quality.
 * @author Ce Zhang
 *
 */
public class CorefTest{
	
	public static ArrayList<Double> planCosts = new ArrayList<Double>();
	public static String exeTime = "";
		
	/**
	 * Test Coref's quality on a test case which has manually-built ground truth.
	 */
	@Test
	public final void testCorefMAP() {
		try{
			String[] args = {"-e", "test/felix/coref_test/evid.db", "-i", "test/felix/coref_test/prog.mln",
					"-o", "test/testOutput.txt_coref", "-queryFile", "test/felix/coref_test/query.db", "-keepData"};
			
			for(int wwww = 0; wwww < 2; wwww++){
				
				FelixConfig.overrideID();
				FelixCommandOptions options = FelixUIMan.parseCommand(args);
				
				if(wwww == 1){
					options.useDualDecomposition = true;
					FelixConfig.nDDIT = 2;
				}
				
				String outfile = "test/testOutput.txt_coref";
				
				if(wwww == 1){
					outfile = outfile + "_snap_0";
				}
				
				
				new Felix().run(options);
				
				BufferedReader br = new BufferedReader(new FileReader(outfile));
				Pattern p = Pattern.compile("coref_map\\(\"(.*?)\", \"(.*?)\"\\)");
				String line;
				Integer five = -1;
				Integer six = -1;
				while( (line = br.readLine()) != null ){
					Matcher m = p.matcher(line);
					m.find();
					Integer n1 = Integer.valueOf(m.group(1));
					Integer n2 = Integer.valueOf(m.group(2));
					if(n1 != n2){
						if(n1 == 1 || n1 == 2 || n1 == 3 || n1 == 9){
							assertTrue(n2 == 1 || n2 == 2 || n2 == 3 || n2 == 9);
						}else if(n1 ==4 || n1 ==5 || n1 ==6){
							assertTrue(n2 == 4 || n2 ==5 || n2 ==6);
						}else if(n1 == 7){
							assertTrue(n2 == 7);
						}else if(n1 == 8){
							assertTrue(n2 == 8);
						}else{
							assertTrue(false);
						}
					}
					
					if(n1 == 5){
						five = n2;
					}
					if(n1 == 6){
						six = n2;
					}
				}
				
				System.out.println(five);
				System.out.println(six);
				System.out.println(five.equals(six));
				assertFalse(five.equals(six));
				
			}
			
		}catch(Exception e){
			e.printStackTrace();
			assertTrue(false);
		}
	}
	
	
	
}






