package felix.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;

import tuffy.util.StringMan;

/**
 * Container of string related utilities.
 */
public class FelixStringMan extends StringMan{
	
	/**
	 * Returns comma separated list with no spaces for given list.
	 * @param parts
	 * @return
	 */
	public static String commaListNoSpace(ArrayList<String> parts) {
		return StringMan.join(",", parts);
	}
	
	/**
	 * Returns current indentation.
	 * @return
	 */
	public static String indentHead(){
		String ret = "";
		for(int i=0;i<FelixConfig.currentIndent;i++){
			ret += "\t";
		}
		return ret;
	}
	
	/**
	 * Returns newline + current indentation.
	 * @return
	 */
	public static String nextLine(){
		String ret = "\n";
		for(int i=0;i<FelixConfig.currentIndent;i++){
			ret += "\t";
		}
		return ret;
	}
	
	/**
	 * Returns HashSet for given object.
	 * @param obj
	 * @return
	 */
	public static <A> HashSet<A> toHashSet(A obj){
		HashSet<A> ret = new HashSet<A>();
		ret.add(obj);
		return ret;
	}
	
	/**
	 * Returns ArrayList for given collection.
	 * @param _coll
	 * @return
	 */
	public static <A> ArrayList<String> colToStringArray(Collection<A> _coll){
		ArrayList<String> ret = new ArrayList<String>();
		for(A a : _coll){
			ret.add(a.toString());
		}
		return ret;
	}
	
	/**
	 * Returns ArrayList for given object.
	 * @param _coll
	 * @return
	 */
	public static <A> ArrayList<String> colToStringArray(A... _coll){
		ArrayList<String> ret = new ArrayList<String>();
		for(A a : _coll){
			ret.add(a.toString());
		}
		return ret;
	}
	
}
