package tuffy.util;

/**
 * Container for global configuration parameters.
 */
public class Config {

	public static String product_line = "tuffy";
	public static String product_name = "Tuffy 0.3";
	public static String path_conf = "./tuffy.conf";
	
	public static boolean snapshot_mode = false;
	public static boolean snapshoting_so_do_not_do_init_flip = false;
	public static int currentSampledNumber = 0;
	
	/**
	 * Runtime
	 */
	public static boolean exiting_mode = false;
	public static boolean learning_mode = false;
	
	public static String display_marker;
	
	/**
	 * DB
	 */
	public static String relConstants = "constants";
	public static String db_url = "jdbc:postgresql://localhost:5432/lmn";
	public static String db_username = "tuffer";
	public static String db_password = "strongPasswoRd";
	public static String db_schema = "tuffy_testing";

	/**
	 * File System
	 */
	public static String dir_working = "/tmp/tuffy-workspace";
	public static String dir_out = ".";
	public static boolean output_files_in_gzip = false;
	public static String dir_tests = "/tmp/tuffy-tests";
	public static String file_stats = "tuffy_stats.txt";
	
	/**
	 * System
	 */
	public static boolean disable_partition = false;
	public static int max_threads = 0;
	public static boolean build_predicate_table_indexes = false;
	public static int evidence_file_chunk_size = 1<<22;
	public static double partition_size_bound = 1 << 30;
	public static double ram_size = 1 << 30;

    public static String evidDBSchema = null;
    public static boolean dbNeedTranslate = false;
    
	/**
	 * Inference
	 */
	public static boolean use_atom_blocking = false;
	public static boolean mark_all_atoms_active = false;
	public static boolean stop_samplesat_upon_sat = false;

	public static double soft_evidence_activation_threshold = 0.25;
	public static double samplesat_sa_coef = 10;
	public static double mcsat_sample_para = 1;
	public static double hard_weight = 5.2E7;
	public static double hard_threshold = 1E7;
	public static double walksat_random_step_probability = 0.5;
	public static double sweepsat_greedy_probability = 0.5;
	public static boolean avoid_breaking_hard_clauses = false;
	public static boolean apply_greedy_throttling = true;

	public static enum TUFFY_INFERENCE_TASK {MAP, MARGINAL};
	
	public static int gauss_seidel_infer_rounds = 5;
	
	/**
	 * UI
	 */
	public static int verbose_level = 0;
	public static String console_line_header = null;
	public static boolean clause_display_multiline = true;

	public static enum MCSAT_OUTPUT_TUPLE_ORDER {PROBABILITY, PRED_ARGS};
	public static MCSAT_OUTPUT_TUPLE_ORDER mcsat_output_order =
		MCSAT_OUTPUT_TUPLE_ORDER.PROBABILITY;

	public static double marginal_output_min_prob = 0;
	public static boolean mcsat_output_hidden_atoms = false;
	

	/**
	 * Helper
	 */
	public static int mcsatDumpPeriodSamples = 20;
	public static int mcsatDumpPeriodSeconds = 0;

	public static boolean output_prolog_format = false;
	public static boolean output_prior_with_marginals = true;
	public static boolean throw_exception_when_dying = false;

	public static boolean keep_db_data = false;

	public static boolean track_clause_provenance = false;
	public static boolean reorder_literals = false;

	public static double timeout = Double.MAX_VALUE;
	public static int num_tries_per_periodic_flush = 0;
	
	
	/**
	 * Research
	 */
	public static boolean checkNumCriticalNodes = false;
	public static boolean focus_on_critical_atoms = false;
	
	
	
	
	
	
	public static int getNumThreads(){
		if(max_threads > 0) return max_threads;
		return Runtime.getRuntime().availableProcessors();
	}
	

	public static String getLoadingDir(){
		String path = dir_working + "/loading";
		FileMan.ensureExistence(path);
		return path;
	}
	
	public static String getWorkingDir(){
		return dir_working;
	}
	
}
